%define fedora		0
%define redhat		1
%if %{fedora}
%define gcj_support 	1
%else
%define gcj_support 	0
%endif
%define pkg_summary             Eclipse Modeling Framework (EMF)
%define eclipse_name            eclipse
%define major                   2
%define minor                   2
%define majmin                  %{major}.%{minor}
%define micro                   0
%define eclipse_base            %{_datadir}/%{eclipse_name}
%define eclipse_lib_base        %{_libdir}/%{eclipse_name}

# All arches line up except i386 -> x86
%ifarch %{ix86}
%define eclipse_arch    x86
%else
%define eclipse_arch   %{_arch}
%endif

Summary:        %{pkg_summary}
Name:           %{eclipse_name}-emf
Version:        %{majmin}.%{micro}
Release:        1jpp_2rh
License:        Eclipse Public License - v 1.0 (EPL) <http://www.eclipse.org/legal/epl-v10.html>
Group:          Text Editors/Integrated Development Environments (IDE)
URL:            http://www.eclipse.org/emf/
Requires:	eclipse-platform

# Here's how to generate the source drop for EMF 2.2.0:
#
# mkdir -p temp/home && cd temp
# touch home/.cvspass
# cvs -d :pserver:anonymous@dev.eclipse.org:/home/tools \
#   co -r build_200606271057 org.eclipse.emf.releng.build
# pushd org.eclipse.emf.releng.build
# 
# # These patches do the following:
# #   1. add a fetch target to grab the source
# #   2. make it so that we don't have to strip the version at source grab time
# #      (and thus depend upon org.eclipse.releng
# patch -p0 << _EOF_
# Index: build.xml
# ===================================================================
# RCS file: /home/tools/org.eclipse.emf.releng.build/build.xml,v
# retrieving revision 1.14
# diff -u -p -r1.14 build.xml
# --- build.xml	7 Nov 2005 20:37:26 -0000	1.14
# +++ build.xml	13 Jul 2006 02:09:10 -0000
# @@ -44,4 +44,15 @@
#  			<property name="builder" value="${basedir}/${component}" />
#  		</ant>
#  	</target>
# -</project>
# \ No newline at end of file
# +       <target name="fetch" depends="init">
# +               <ant antfile="build.xml" dir="\${pde.build.scripts}"
# +                               target="preBuild">
# +                       <property name="builder" value="\${basedir}/\${component}" />
# +               </ant>
# +               <ant antfile="build.xml" dir="\${pde.build.scripts}"
# +                               target="fetch">
# +                       <property name="builder" value="\${basedir}/\${component}" />
# +               </ant>
# +       </target>
# +
# +</project>
# Index: sdk/customTargets.xml
# ===================================================================
# RCS file: /home/tools/org.eclipse.emf.releng.build/sdk/customTargets.xml,v
# retrieving revision 1.35
# diff -u -p -r1.35 customTargets.xml
# --- sdk/customTargets.xml	26 Jun 2006 08:05:05 -0000	1.35
# +++ sdk/customTargets.xml	13 Jul 2006 02:09:10 -0000
# @@ -28,7 +28,6 @@
#    <!-- Replace values for cvsRoot, package and mapVersionTag as desired. -->
#    <!-- ===================================================================== -->
#    <target name="checkLocal">
# -    <available property="mapsLocal" file="${buildDirectory}/maps/org.eclipse.emf" />
#    </target>
#  
#    <target name="getMapFiles" depends="checkLocal" unless="mapsLocal">
# @@ -206,11 +205,11 @@
#    </target>
#  
#    <target name="getBaseInit">
# -    <taskdef name="stripVersions" classname="org.eclipse.releng.VersionNumberStripper" />
#      <property file="${buildDirectory}/maps/org.eclipse.emf/build.cfg" />
#    </target>
#  
#    <target name="getBaseEclipse" unless="baseExists" depends="getBaseInit">
# +    <taskdef name="stripVersions" classname="org.eclipse.releng.VersionNumberStripper" />
#      <!-- if there's already an existing eclipse zip by the same name in the dest folder, don't download it again! -->
#      <available file="${downloadsDir}/${eclipseFile}" property="baseZipExists" />
#      <antcall target="downloadBaseEclipse" />
# _EOF_
# 
# # Fetch the actual source
# 
# java -cp /usr/share/eclipse/startup.jar \
#   -Duser.home=../home org.eclipse.core.launcher.Main \
#   -application org.eclipse.ant.core.antRunner \
#   -buildfile build.xml \
#   -DbaseLocation=/usr/share/eclipse \
#   -Dpde.build.scripts=/usr/share/eclipse/plugins/org.eclipse.pde.build/scripts \
#   -Dcomponent=sdk \
#   -DbaseExists=true \
#   -DbuildLabel=build_200606271057 \
#   -DfetchTag=build_200606271057 \
#   -DmapCvsRoot=":pserver:anonymous@dev.eclipse.org:/home/tools" \
#   -DmapVersionTag=build_200606271057 \
#   fetch
#   
# popd
# 
# # Make the source tarball
# tar jcf eclipse-emf-fetched-src-2.2.0.tar.bz2 org.eclipse.emf.releng.build

Source0:	%{name}-fetched-src-%{version}.tar.bz2
# This is needed for building.  It was not included in CVS on 2006-07-17 so
# Nick Boldt posted the following zip on the eclipse.tools.emf newsgroup on
# 2006-07-18 Subject:  Re: emf.build.SetRequiredBundleVersionRanges
# Message ID:  e9j005$63v$1@utils.eclipse.org
# --overholt
Source1:	org.eclipse.emf.build.ant.zip

Patch0:		%{name}-customTargets.xml.patch
Patch1:		%{name}-nobootclasspath.patch
# Note, this patch includes the Eclipse SDK version number
Patch2:		%{name}-javadoc.patch
Patch3:		%{name}-addforceContextQualiferproperty.patch
Patch4:		%{name}-build.ant.patch
Patch5:		%{name}-buildAll.patch

BuildRequires:	eclipse-pde-sdk
%if %{gcj_support}
BuildRequires:    gcc-java >= 4.0.2
BuildRequires:    java-gcj-compat-devel >= 1.0.33
Requires(post):   java-gcj-compat >= 1.0.33
Requires(postun): java-gcj-compat >= 1.0.33
%else
BuildRequires:    java-devel >= 1.4.2
%endif

%if %{gcj_support}
ExclusiveArch:    %{ix86} x86_64 ppc ia64
%else
BuildArch:        noarch
%endif

Requires:       eclipse-platform >= 1:3.2.0
Requires:       eclipse-platform < 1:3.2.1

BuildRoot: %{_tmppath}/%{name}-buildroot

%package	sdo
Summary:        Eclipse EMF XSD
Group:          Text Editors/Integrated Development Environments (IDE)
Requires:       eclipse-platform >= 1:3.2.0
Requires:       eclipse-platform < 1:3.2.1

%package	sdo-sdk
Summary:        Eclipse EMF SDO Source (SDK)
Group:          Text Editors/Integrated Development Environments (IDE)
Requires:       %{name}-sdo = %{version}-%{release}

%package	xsd
Summary:        Eclipse EMF XSD
Group:          Text Editors/Integrated Development Environments (IDE)
Requires:       eclipse-platform >= 1:3.2.0
Requires:       eclipse-platform < 1:3.2.1

%package	xsd-sdk
Summary:        Eclipse EMF XSD Source (SDK)
Group:          Text Editors/Integrated Development Environments (IDE)
Requires:       %{name}-xsd = %{version}-%{release}

%description
EMF is a modeling framework and code generation facility for building tools and
other applications based on a structured data model.

%description	sdo
Service Data Objects (SDO) is a framework that simplifies and unifies data
application development in a service oriented architecture (SOA).

%description	sdo-sdk
Source for Eclipse EMF SDO for use within Eclipse.

%description	xsd
The XML Schema Infoset Model is a reference library that provides an API for use
with any code that examines, creates or modifies W3C XML Schema (standalone or
as part of other artifacts, such as XForms or WSDL documents). 

%description	xsd-sdk
Source for Eclipse EMF XSD for use within Eclipse.

%prep
%setup -q -c
%patch0 -p0
pushd org.eclipse.emf.releng.build
%patch1 -p0
%patch2 -p1
%patch3 -p0
%patch5 -p0

# Don't ever use bootclasspath
# FIXME:  why can't we use bootclasspath?  It gives the infamous
# "java.lang.Object cannot be found" error.
for f in emf/doc/build.properties emf/runtime/build.properties \
    examples/build.properties sdk/build.properties sdo/doc/build.properties \
    sdo/runtime/build.properties tests/build.properties \
    xsd/doc/build.properties xsd/runtime/build.properties; \
do sed --in-place 's/^bootclasspath/#bootclasspath/' $f; done
popd

# A location to build the EMF ant helper jar
mkdir emf-ant-build
unzip -qq -d emf-ant-build %{SOURCE1}
pushd emf-ant-build
%patch4 -p1
popd

%build
mkdir home
homedir=$(cd home > /dev/null && pwd)

# See comments in the script to understand this.
/bin/sh -x %{eclipse_base}/buildscripts/copy-platform SDK %{eclipse_base}
SDK=$(cd SDK && pwd)

# Build the EMF builder helper jars

# for ChangeBundleClasspath
pushd org.eclipse.emf.releng.build/org.eclipse.emf.build
ant
popd

# for SetRequiredBundleVersionRanges
pushd emf-ant-build
mkdir -p build

echo "<project default=\"main\"><target name=\"main\"></target></project>" > build/assemble.org.eclipse.emf.build.ant.all.xml
echo "<project default=\"main\"><target name=\"main\"></target></project>" > build/package.org.eclipse.emf.build.ant.all.xml

java -cp %{eclipse_base}/startup.jar                   \
     -Duser.home=$homedir                              \
     org.eclipse.core.launcher.Main                    \
     -application org.eclipse.ant.core.antRunner       \
     -Dtype=plugin                                    \
     -Did=org.eclipse.emf.build.ant                   \
     -DsourceDirectory=$(pwd)                          \
     -DbaseLocation=$SDK                               \
     -Dbuilder=%{eclipse_base}/plugins/org.eclipse.pde.build/templates/package-build  \
     -f %{eclipse_base}/plugins/org.eclipse.pde.build/scripts/build.xml

pushd build/plugins/org.eclipse.emf.build.ant
java -cp /usr/share/eclipse/startup.jar                   \
     -Duser.home=$homedir                              \
     org.eclipse.core.launcher.Main                    \
     -application org.eclipse.ant.core.antRunner       \
     -f build.xml build.update.jar
popd

# FIXME:  the SDK symlinks that point to /usr/share/eclipse end up causing the
# antRunner process below to not see anything in $SDK that *isn't* in
# /usr/share/eclipse.  As such, I've hacked this up to temporarily duplicate
# everything in /usr/share/eclipse and copy the emf.build.ant jar there for
# building.  Lame, yes, but it works and it only results in a bloated buildroot
# which is just temporary disk space.  Also, the task itself expects to have
# all of the plugins (including the SDK plugins themselves) in
# org.eclipse.emf.releng.build/src/eclipse/plugins so we symlink the SDK ones there.
# -- overholt 2006-07-27

pushd ..
rm SDK/plugins/org.eclipse.pde.build
cp -rL SDK SDK2
pushd SDK2/plugins 
ln -s org.eclipse.pde.build* org.eclipse.pde.build
popd
rm -rf SDK
mv SDK2 SDK
SDK=$(cd SDK && pwd)
popd

pushd ../org.eclipse.emf.releng.build/src/eclipse/plugins
for f in `ls $SDK/plugins`; do ln -s $SDK/plugins/$f .; done
popd

# Make EMF ant task available to main EMF build
mv build/plugins/org.eclipse.emf.build.ant/*.jar $SDK/plugins
popd
# End build of EMF builder helper jar

cd org.eclipse.emf.releng.build

# some notes about what we're doing here:
#
# -Duser.home=$homedir: override java.home in the vm so that eclipse only adds files in the buildroot 
# -Dcomponent=sdk: the component of EMF we want to build 
# -DjavacFailOnError=true: fail if there is an error 
# -DdontUnzip=true: don't unzip the result, we will do it manually
# -DbaseLocation=$SDK: $SDK is a mirror of the system SDK dir that is writable by the process 
#                      running the build. This let's the build "see" the jars and have a place to 
#                      put the plugins that have just been built
# -DskipFetch=true: don't fetch the sources 
# -DbaseExists=true: don't download the SDK, we want to use the one in $SDK
java -cp $SDK/startup.jar \
    -Duser.home=$homedir			\
     org.eclipse.core.launcher.Main		\
    -application org.eclipse.ant.core.antRunner	\
    -DjavacFailOnError=true    			\
    -DdontUnzip=true				\
    -DmapsLocal=true				\
    -DbaseLocation=$SDK				\
    -Dpde.build.scripts=$SDK/plugins/org.eclipse.pde.build/scripts \
    -DskipFetch=true				\
    -DbuildLabel=%{version}			\
    -DbuildAlias=%{version}			\
    -DbaseExists=true \
    -f buildAll.xml buildRPM

%install
rm -rf ${RPM_BUILD_ROOT}
install -d -m755 ${RPM_BUILD_ROOT}/%{eclipse_base}

for file in $(pwd)/org.eclipse.emf.releng.build/src/eclipse/%{version}/*.zip; do
  case $file in
    *eclipse*)
      # The ".." is needed since the zip files contain "eclipse/foo".
      (cd $RPM_BUILD_ROOT/%{eclipse_base}/.. && unzip -qq -o $file)
      ;;
  esac
done

# These are already included in the Eclipse SDK
rm $RPM_BUILD_ROOT/%{eclipse_base}/epl-v10.html
rm $RPM_BUILD_ROOT/%{eclipse_base}/notice.html

%if %{gcj_support}
  aot-compile-rpm
%endif

%clean 
rm -rf ${RPM_BUILD_ROOT}

%if %{gcj_support}
%post sdo
%{_bindir}/rebuild-gcj-db
%postun sdo
%{_bindir}/rebuild-gcj-db
%post xsd
%{_bindir}/rebuild-gcj-db
%postun xsd
%{_bindir}/rebuild-gcj-db
%endif

%files sdo
%defattr(-,root,root)
%{eclipse_base}/features/org.eclipse.emf_*
%{eclipse_base}/features/org.eclipse.emf.doc_*
%{eclipse_base}/features/org.eclipse.emf.ecore.sdo_*
%{eclipse_base}/features/org.eclipse.emf.ecore.sdo.doc_*
%{eclipse_base}/plugins/org.eclipse.emf.ant_*
%{eclipse_base}/plugins/org.eclipse.emf.cheatsheets_*
%{eclipse_base}/plugins/org.eclipse.emf.codegen.ecore.ui_*
%{eclipse_base}/plugins/org.eclipse.emf.codegen.ecore_*
%{eclipse_base}/plugins/org.eclipse.emf.codegen.ui_*
%{eclipse_base}/plugins/org.eclipse.emf.codegen_*
%{eclipse_base}/plugins/org.eclipse.emf.common.ui_*
%{eclipse_base}/plugins/org.eclipse.emf.common_*
%{eclipse_base}/plugins/org.eclipse.emf.commonj.sdo_*
%{eclipse_base}/plugins/org.eclipse.emf.converter_*
%{eclipse_base}/plugins/org.eclipse.emf.doc_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.change.edit_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.change_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.edit_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.editor_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.sdo.doc_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.sdo.edit_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.sdo.editor_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.sdo_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.xmi_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore_*
%{eclipse_base}/plugins/org.eclipse.emf.edit.ui_*
%{eclipse_base}/plugins/org.eclipse.emf.edit_*
%{eclipse_base}/plugins/org.eclipse.emf.exporter_*
%{eclipse_base}/plugins/org.eclipse.emf.importer.ecore_*
%{eclipse_base}/plugins/org.eclipse.emf.importer.java_*
%{eclipse_base}/plugins/org.eclipse.emf.importer.rose_*
%{eclipse_base}/plugins/org.eclipse.emf.importer_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping.ecore2ecore.editor_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping.ecore2ecore_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping.ecore2xml.ui_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping.ecore2xml_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping.ui_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping_*
%{eclipse_base}/plugins/org.eclipse.emf_*
%if %{gcj_support}
%{_libdir}/gcj/%{name}/doc.zip*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ant_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.codegen.ecore.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.codegen.ecore_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.codegen.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.codegen_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.common.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.common_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.commonj.sdo_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.change.edit_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.change_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.edit_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.editor_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.sdo.edit_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.sdo.editor_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.sdo_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore.xmi_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.ecore_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.edit.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.edit_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.importer.ecore_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.importer.java_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.importer.rose_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.importer_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping.ecore2ecore.editor_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping.ecore2ecore_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping.ecore2xml.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping.ecore2xml_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping.ui_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping_*
%endif

%files sdo-sdk
%defattr(-,root,root)
%{eclipse_base}/features/org.eclipse.emf.ecore.sdo.source_*
%{eclipse_base}/features/org.eclipse.emf.source_*
%{eclipse_base}/features/org.eclipse.emf.sdk_*
%{eclipse_base}/plugins/org.eclipse.emf.ecore.sdo.source_*
%{eclipse_base}/plugins/org.eclipse.emf.source_*

%files xsd
%defattr(-,root,root)
%{eclipse_base}/features/org.eclipse.xsd_*
%{eclipse_base}/features/org.eclipse.xsd.doc_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping.xsd2ecore.editor_*
%{eclipse_base}/plugins/org.eclipse.emf.mapping.xsd2ecore_*
%{eclipse_base}/plugins/org.eclipse.xsd.cheatsheets_*
%{eclipse_base}/plugins/org.eclipse.xsd.doc_*
%{eclipse_base}/plugins/org.eclipse.xsd.ecore.importer_*
%{eclipse_base}/plugins/org.eclipse.xsd.ecore.exporter_*
%{eclipse_base}/plugins/org.eclipse.xsd.edit_*
%{eclipse_base}/plugins/org.eclipse.xsd.editor_*
%{eclipse_base}/plugins/org.eclipse.xsd_*
%if %{gcj_support}
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping.xsd2ecore.editor_*
%{_libdir}/gcj/%{name}/org.eclipse.emf.mapping.xsd2ecore_*
%{_libdir}/gcj/%{name}/org.eclipse.xsd.ecore.importer_*
%{_libdir}/gcj/%{name}/org.eclipse.xsd.edit_*
%{_libdir}/gcj/%{name}/org.eclipse.xsd.editor_*
%{_libdir}/gcj/%{name}/org.eclipse.xsd_*
%endif

%files xsd-sdk
%defattr(-,root,root)
%{eclipse_base}/features/org.eclipse.xsd.source_*
%{eclipse_base}/plugins/org.eclipse.xsd.source_*

%changelog
* Tue Aug 22 2006 Andrew Overholt <overholt@redhat.com> 2.2.0-1jpp_2rh
- -devel -> -sdk to match upstream.

* Tue Aug 01 2006 Andrew Overholt <overholt@redhat.com> 2.2.0-1jpp_1rh
- 2.2.0
- Build using buildAll.xml
- Require eclipse-pde-sdk to ensure we have the latest of all of the SDK.

* Fri Apr 07 2006 Andrew Overholt <overholt@redhat.com> 2.1.2-1jpp_1rh
- 2.1.2
- Specfile cleanup.

* Thu Mar 17 2005 Jeff Pound <jpound@redhat.com> 2.0.1-4
- Change pde build script location to 3.0.1.

* Wed Mar 16 2005 Phil Muldoon <pmuldoon@redhat.com> 2.0.1-3
- Fixed description

* Fri Oct 29 2004 Phil Muldoon <pmuldoon@redhat.com> 2.0.1-2
- Modified tar-ball to reflect version	

* Wed Oct 27 2004 Phil Muldoon <pmuldoon@redhat.com> 2.0.1-1
- Initial Import
